diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/model/zigbee-nwk-header.cc ns-3.44/src/zigbee/model/zigbee-nwk-header.cc
--- ns-3.43/src/zigbee/model/zigbee-nwk-header.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/model/zigbee-nwk-header.cc	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,413 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors:
+ *  Ryo Okuda  <c611901200@tokushima-u.ac.jp>
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-nwk-header.h"
+
+#include "ns3/address-utils.h"
+
+namespace ns3
+{
+namespace zigbee
+{
+
+ZigbeeNwkHeader::ZigbeeNwkHeader()
+{
+    SetFrameType(DATA);
+    SetProtocolVer(3);
+    SetDiscoverRoute(DiscoverRouteType::SUPPRESS_ROUTE_DISCOVERY);
+    m_fctrlMcst = false;
+    m_fctrlSecurity = false;
+    m_fctrlSrcRoute = false;
+    m_fctrlDstIEEEAddr = false;
+    m_fctrlSrcIEEEAddr = false;
+    m_fctrlEndDevIni = false;
+}
+
+ZigbeeNwkHeader::~ZigbeeNwkHeader()
+{
+}
+
+void
+ZigbeeNwkHeader::SetFrameType(enum NwkType nwkType)
+{
+    m_fctrlFrmType = nwkType;
+}
+
+NwkType
+ZigbeeNwkHeader::GetFrameType() const
+{
+    return m_fctrlFrmType;
+}
+
+void
+ZigbeeNwkHeader::SetProtocolVer(uint8_t ver)
+{
+    m_fctrlPrtVer = ver;
+}
+
+uint8_t
+ZigbeeNwkHeader::GetProtocolVer() const
+{
+    return (m_fctrlPrtVer);
+}
+
+void
+ZigbeeNwkHeader::SetDiscoverRoute(enum DiscoverRouteType discoverRoute)
+{
+    m_fctrlDscvRoute = discoverRoute;
+}
+
+DiscoverRouteType
+ZigbeeNwkHeader::GetDiscoverRoute() const
+{
+    return m_fctrlDscvRoute;
+}
+
+void
+ZigbeeNwkHeader::SetMulticast()
+{
+    m_fctrlMcst = true;
+}
+
+bool
+ZigbeeNwkHeader::IsMulticast() const
+{
+    return m_fctrlMcst;
+}
+
+bool
+ZigbeeNwkHeader::IsSecurityEnabled() const
+{
+    return m_fctrlSecurity;
+}
+
+void
+ZigbeeNwkHeader::SetEndDeviceInitiator()
+{
+    m_fctrlEndDevIni = true;
+}
+
+bool
+ZigbeeNwkHeader::GetEndDeviceInitiator() const
+{
+    return m_fctrlEndDevIni;
+}
+
+void
+ZigbeeNwkHeader::SetDstAddr(Mac16Address addr)
+{
+    m_dstAddr = addr;
+}
+
+Mac16Address
+ZigbeeNwkHeader::GetDstAddr() const
+{
+    return (m_dstAddr);
+}
+
+void
+ZigbeeNwkHeader::SetSrcAddr(Mac16Address addr)
+{
+    m_srcAddr = addr;
+}
+
+Mac16Address
+ZigbeeNwkHeader::GetSrcAddr() const
+{
+    return (m_srcAddr);
+}
+
+void
+ZigbeeNwkHeader::SetRadius(uint8_t radius)
+{
+    m_radius = radius;
+}
+
+uint8_t
+ZigbeeNwkHeader::GetRadius() const
+{
+    return (m_radius);
+}
+
+void
+ZigbeeNwkHeader::SetSeqNum(uint8_t seqNum)
+{
+    m_seqNum = seqNum;
+}
+
+uint8_t
+ZigbeeNwkHeader::GetSeqNum() const
+{
+    return (m_seqNum);
+}
+
+void
+ZigbeeNwkHeader::SetDstIeeeAddr(Mac64Address dst)
+{
+    m_fctrlDstIEEEAddr = true;
+    m_dstIeeeAddr = dst;
+}
+
+Mac64Address
+ZigbeeNwkHeader::GetDstIeeeAddr() const
+{
+    return (m_dstIeeeAddr);
+}
+
+void
+ZigbeeNwkHeader::SetSrcIeeeAddr(Mac64Address src)
+{
+    m_fctrlSrcIEEEAddr = true;
+    m_srcIeeeAddr = src;
+}
+
+Mac64Address
+ZigbeeNwkHeader::GetSrcIeeeAddr() const
+{
+    return (m_srcIeeeAddr);
+}
+
+void
+ZigbeeNwkHeader::SetFrameControl(uint16_t frameControl)
+{
+    m_fctrlFrmType = static_cast<NwkType>((frameControl) & (0x03));                  // Bit 0-1
+    m_fctrlPrtVer = (frameControl >> 2) & (0x0F);                                    // Bit 2-5
+    m_fctrlDscvRoute = static_cast<DiscoverRouteType>((frameControl >> 6) & (0x03)); // Bit 6-7
+    m_fctrlMcst = (frameControl >> 8) & (0x01);                                      // Bit 8
+    m_fctrlSecurity = (frameControl >> 9) & (0x01);                                  // Bit 9
+    m_fctrlSrcRoute = (frameControl >> 10) & (0x01);                                 // Bit 10
+    m_fctrlDstIEEEAddr = (frameControl >> 11) & (0x01);                              // Bit 11
+    m_fctrlSrcIEEEAddr = (frameControl >> 12) & (0x01);                              // Bit 12
+    m_fctrlEndDevIni = (frameControl >> 13) & (0x01);                                // Bit 13
+}
+
+uint16_t
+ZigbeeNwkHeader::GetFrameControl() const
+{
+    uint16_t val = 0;
+
+    val = m_fctrlFrmType & (0x03);                    // Bit 0-1
+    val |= (m_fctrlPrtVer << 2) & (0x0F << 2);        // Bit 2-5
+    val |= (m_fctrlDscvRoute << 6) & (0x03 << 6);     // Bit 6-7
+    val |= (m_fctrlMcst << 8) & (0x01 << 8);          // Bit 8
+    val |= (m_fctrlSecurity << 9) & (0x01 << 9);      // Bit 9
+    val |= (m_fctrlSrcRoute << 10) & (0x01 << 10);    // Bit 10
+    val |= (m_fctrlDstIEEEAddr << 11) & (0x01 << 11); // Bit 11
+    val |= (m_fctrlSrcIEEEAddr << 12) & (0x01 << 12); // Bit 12
+    val |= (m_fctrlEndDevIni << 13) & (0x01 << 13);   // Bit 13
+
+    return val;
+}
+
+void
+ZigbeeNwkHeader::SetMulticastControl(uint8_t multicastControl)
+{
+    m_mcstMode = static_cast<MulticastMode>((multicastControl) & (0x03)); // Bit 0-1
+    m_nonMemberRadius = (multicastControl >> 2) & (0x07);                 // Bit 2-4
+    m_maxNonMemberRadius = (multicastControl >> 5) & (0x07);              // Bit 5-7
+}
+
+uint8_t
+ZigbeeNwkHeader::GetMulticastControl() const
+{
+    uint8_t val = 0;
+
+    val = m_mcstMode & (0x03);                        // Bit 0-1
+    val |= (m_nonMemberRadius << 2) & (0x07 << 2);    // Bit 2-4
+    val |= (m_maxNonMemberRadius << 5) & (0x07 << 5); // Bit 5-7
+
+    return val;
+}
+
+void
+ZigbeeNwkHeader::Serialize(Buffer::Iterator start) const
+{
+    Buffer::Iterator i = start;
+
+    uint16_t frameControl = GetFrameControl();
+    i.WriteHtolsbU16(frameControl);
+
+    WriteTo(i, m_dstAddr);
+    WriteTo(i, m_srcAddr);
+    i.WriteU8(m_radius);
+    i.WriteU8(m_seqNum);
+
+    if (m_fctrlDstIEEEAddr)
+    {
+        WriteTo(i, m_dstIeeeAddr);
+    }
+
+    if (m_fctrlSrcIEEEAddr)
+    {
+        WriteTo(i, m_srcIeeeAddr);
+    }
+
+    if (m_fctrlMcst)
+    {
+        i.WriteU8(GetMulticastControl());
+    }
+
+    // TODO: Add Source route subframe when supported
+}
+
+uint32_t
+ZigbeeNwkHeader::Deserialize(Buffer::Iterator start)
+{
+    Buffer::Iterator i = start;
+    uint16_t frameControl = i.ReadLsbtohU16();
+    SetFrameControl(frameControl);
+    ReadFrom(i, m_dstAddr);
+    ReadFrom(i, m_srcAddr);
+    SetRadius(i.ReadU8());
+    SetSeqNum(i.ReadU8());
+
+    if (m_fctrlDstIEEEAddr)
+    {
+        ReadFrom(i, m_dstIeeeAddr);
+    }
+
+    if (m_fctrlSrcIEEEAddr)
+    {
+        ReadFrom(i, m_srcIeeeAddr);
+    }
+
+    if (m_fctrlMcst)
+    {
+        uint8_t multicastControl = i.ReadU8();
+        SetMulticastControl(multicastControl);
+    }
+
+    // TODO: Add Source route subframe when supported
+
+    return i.GetDistanceFrom(start);
+}
+
+uint32_t
+ZigbeeNwkHeader::GetSerializedSize() const
+{
+    /*
+     * Each NWK header will have:
+     *
+     * Frame Control      : 2 octet
+     *
+     * Routing Fields:
+     * Destination address      : 2 octet
+     * Source address           : 2 octet
+     * Radius                   : 1 octet
+     * Sequence number          : 1 octet
+     * Destination IEEE address : 0/8 octet
+     * Source IEEE address      : 0/8 octet
+     * Multicast control        : 0/1 octet
+     * Source route subframe    : variable
+     */
+
+    uint32_t size = 8;
+
+    if (m_fctrlDstIEEEAddr)
+    {
+        size += 8;
+    }
+
+    if (m_fctrlSrcIEEEAddr)
+    {
+        size += 8;
+    }
+
+    if (m_fctrlMcst)
+    {
+        size += 1;
+    }
+
+    // TODO: Add Source route subframe when supported.
+
+    return (size);
+}
+
+TypeId
+ZigbeeNwkHeader::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::zigbee::ZigbeeNwkHeader")
+                            .SetParent<Header>()
+                            .SetGroupName("Zigbee")
+                            .AddConstructor<ZigbeeNwkHeader>();
+    return tid;
+}
+
+TypeId
+ZigbeeNwkHeader::GetInstanceTypeId() const
+{
+    return GetTypeId();
+}
+
+void
+ZigbeeNwkHeader::Print(std::ostream& os) const
+{
+    os << "\n";
+    switch (m_fctrlFrmType)
+    {
+    case DATA:
+        os << "Frame Type = DATA ";
+        break;
+    case NWK_COMMAND:
+        os << "Frame Type = NWK_COMMAND ";
+        break;
+    case INTER_PAN:
+        os << "Frame Type = INTER_PAN  ";
+        break;
+    }
+    os << " | Protocol Version = " << static_cast<uint32_t>(m_fctrlPrtVer)
+       << " | Security Enabled = " << static_cast<uint32_t>(m_fctrlSecurity)
+       << " | Source Route = " << static_cast<uint32_t>(m_fctrlSrcRoute);
+
+    switch (m_fctrlDscvRoute)
+    {
+    case DiscoverRouteType::SUPPRESS_ROUTE_DISCOVERY:
+        os << " | Enable Route Discovery = SUPPRESS ";
+        break;
+    case DiscoverRouteType::ENABLE_ROUTE_DISCOVERY:
+        os << " | Enable Route Discovery = ENABLED ";
+        break;
+    }
+
+    os << "\nDst Addr = " << m_dstAddr << " | Src Addr  = " << m_srcAddr
+       << " | Sequence Num = " << static_cast<uint32_t>(m_seqNum)
+       << " | Radius = " << static_cast<uint32_t>(m_radius);
+
+    if (m_fctrlDstIEEEAddr)
+    {
+        os << "\nDst IEEE Addr = " << m_dstIeeeAddr;
+    }
+
+    if (m_fctrlSrcIEEEAddr)
+    {
+        os << " | Src IEEE Addr  = " << m_srcIeeeAddr;
+    }
+
+    if (m_fctrlMcst)
+    {
+        switch (m_mcstMode)
+        {
+        case MEMBER:
+            os << " | Mcst mode: MEMBER ";
+            break;
+        case NONMEMBER:
+            os << " | Mcst mode: NONMEMBER ";
+            break;
+        }
+
+        os << " | Non Member radius = " << static_cast<uint32_t>(m_nonMemberRadius)
+           << " | Max Non Member radius = " << static_cast<uint32_t>(m_maxNonMemberRadius);
+    }
+    os << "\n";
+
+    // TODO: Add Source route subframe when supported.
+}
+} // namespace zigbee
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/model/zigbee-nwk-header.h ns-3.44/src/zigbee/model/zigbee-nwk-header.h
--- ns-3.43/src/zigbee/model/zigbee-nwk-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/model/zigbee-nwk-header.h	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,270 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors:
+ *  Ryo Okuda  <c611901200@tokushima-u.ac.jp>
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_NWK_HEADER_H
+#define ZIGBEE_NWK_HEADER_H
+
+#include "ns3/header.h"
+#include "ns3/mac16-address.h"
+#include "ns3/mac64-address.h"
+
+namespace ns3
+{
+
+namespace zigbee
+{
+
+/**
+ * Zigbee Specification r22.1.0, Values of the frame Type Sub-field (Table 3-46)
+ */
+enum NwkType
+{
+    DATA = 0,        //!< Data frame type
+    NWK_COMMAND = 1, //!< Network command frame type
+    INTER_PAN = 3    //!< Inter-Pan frame type
+};
+
+/**
+ * Zigbee Specification r22.1.0, Values of the discover route sub-field (Table 3-47)
+ */
+enum DiscoverRouteType
+{
+    SUPPRESS_ROUTE_DISCOVERY = 0x00, //!< Suppress route discovery
+    ENABLE_ROUTE_DISCOVERY = 0x01    //!< Enable route discovery
+};
+
+/**
+ * Zigbee Specification r22.1.0, Multicast Mode Sub-Field (Table 3-7)
+ */
+enum MulticastMode
+{
+    NONMEMBER = 0, //!< Non member multicast mode
+    MEMBER = 1,    //!< Member multicast mode
+};
+
+/**
+ * @ingroup zigbee
+ * Represent the NWK Header with the Frame Control and Routing fields
+ * Zigbee Specification r22.1.0, General NPDU Frame Format (Section 3.3.1)
+ */
+class ZigbeeNwkHeader : public Header
+{
+  public:
+    ZigbeeNwkHeader();
+
+    ~ZigbeeNwkHeader() override;
+
+    /**
+     * Set the Frame type used (Data or Command)
+     * @param nwkType The frame type
+     */
+    void SetFrameType(enum NwkType nwkType);
+
+    /**
+     * Set the Frame Control field "Frame Type" bits
+     * @return The frame type
+     */
+    NwkType GetFrameType() const;
+
+    /**
+     * Set the Protocol version
+     * @param ver The protocol version
+     */
+    void SetProtocolVer(uint8_t ver);
+
+    /**
+     * Get Frame protocol version
+     * @return The protocol version used by the frame
+     */
+    uint8_t GetProtocolVer() const;
+
+    /**
+     *  Suppress or enable route discovery for this frame
+     * @param discoverRoute Suppress or enable route discovery
+     */
+    void SetDiscoverRoute(enum DiscoverRouteType discoverRoute);
+
+    /**
+     * Get the status of frame discovery route (suppress or enabled)
+     * @return The discovery route status
+     */
+    DiscoverRouteType GetDiscoverRoute() const;
+
+    /**
+     * Set to true the value of the multicast flag in the frame control field.
+     */
+    void SetMulticast();
+
+    /**
+     * Inform whether or not the current frame is used in multicast.
+     * @return  True = MCST false = UCST or BCST
+     */
+    bool IsMulticast() const;
+
+    /**
+     * Inform whether or not security is enabled.
+     * @return True security enabled.
+     */
+    bool IsSecurityEnabled() const;
+
+    /**
+     * This flag is used by the NWK to indicate if the the initiator device of the
+     * message is an end device and the nwkParentInformation field of the NIB has other value than
+     * 0.
+     */
+    void SetEndDeviceInitiator();
+
+    /**
+     * Get whether or not the source of this message was an end device.
+     * @return True of the source of the message was an end device.
+     */
+    bool GetEndDeviceInitiator() const;
+
+    /**
+     * Set Destination address
+     * @param addr The destination address (16 bit)
+     */
+    void SetDstAddr(Mac16Address addr);
+
+    /**
+     * Get the Destination address
+     * @return the Destination address (16bits)
+     */
+    Mac16Address GetDstAddr() const;
+
+    /**
+     * Set Source address
+     * @param addr The source address (16 bit)
+     */
+    void SetSrcAddr(Mac16Address addr);
+
+    /**
+     * Get the Source address
+     * @return the Source address (16bits)
+     */
+    Mac16Address GetSrcAddr() const;
+
+    /**
+     * Set the Radius
+     * @param radius radius
+     */
+    void SetRadius(uint8_t radius);
+
+    /**
+     * Get the Radius
+     * @return the Radius
+     */
+    uint8_t GetRadius() const;
+
+    /**
+     * Set the Sequence number
+     * @param seqNum sequence number
+     */
+    void SetSeqNum(uint8_t seqNum);
+
+    /**
+     * Get the frame Sequence number
+     * @return the sequence number
+     */
+    uint8_t GetSeqNum() const;
+
+    /**
+     *  Set the destination IEEE address
+     *  @param dst The destination IEEE address (64 bits)
+     */
+    void SetDstIeeeAddr(Mac64Address dst);
+
+    /**
+     * Get the destination IEEE address
+     * @return The destination IEEE address (64bits)
+     */
+    Mac64Address GetDstIeeeAddr() const;
+
+    /**
+     * Set the source IEEE address
+     * @param src The source IEEE address
+     */
+    void SetSrcIeeeAddr(Mac64Address src);
+
+    /**
+     * Get the source IEEE address
+     * @return The source IEEE address (64bits)
+     */
+    Mac64Address GetSrcIeeeAddr() const;
+
+    void Serialize(Buffer::Iterator start) const override;
+    uint32_t Deserialize(Buffer::Iterator start) override;
+    uint32_t GetSerializedSize() const override;
+    /**
+     * Get the type ID.
+     *
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+    TypeId GetInstanceTypeId() const override;
+    void Print(std::ostream& os) const override;
+
+  private:
+    /**
+     * Set the Frame control field
+     * @param frameControl 16 bits representing the frame control
+     */
+    void SetFrameControl(uint16_t frameControl);
+    /**
+     * Get the Frame control field
+     * @return The 16 bits of the Frame control field
+     */
+    uint16_t GetFrameControl() const;
+    /**
+     * Set the Multicast control field
+     * @param multicastControl 8 bits representing the multicast control field
+     */
+    void SetMulticastControl(uint8_t multicastControl);
+    /**
+     * Get The Multicast control field
+     * @return The 8 bits representing the multicast control field
+     */
+    uint8_t GetMulticastControl() const;
+
+    /* Frame Control (2 Octets) */
+
+    NwkType m_fctrlFrmType;             //!< Frame type (Bit 0-1)
+    uint8_t m_fctrlPrtVer;              //!< Protocol version (Bit 2-5)
+    DiscoverRouteType m_fctrlDscvRoute; //!< Discover route (Bit 6-7)
+    bool m_fctrlMcst;                   //!< Multicast flag (Bit 8)
+    bool m_fctrlSecurity;               //!< Security flag (Bit 9)
+    bool m_fctrlSrcRoute;               //!< Source route flag (Bit 10)
+    bool m_fctrlDstIEEEAddr;            //!< Destination IEEE address flag (Bit 11)
+    bool m_fctrlSrcIEEEAddr;            //!< Source IEEE address flag (Bit 12)
+    bool m_fctrlEndDevIni;              //!< End device initiator flag (Bit 13)
+                                        // Reserved (Bits 14-15)
+
+    /* Routing Fields (variable) */
+
+    Mac16Address m_dstAddr;     //!< Destination address (2 Octets)
+    Mac16Address m_srcAddr;     //!< Source address (2 Octets)
+    uint8_t m_radius;           //!< Radius (1 Octet)
+    uint8_t m_seqNum;           //!< Sequence number (1 Octet)
+    Mac64Address m_dstIeeeAddr; //!< Destination IEEE address (0 or 8 Octets)
+    Mac64Address m_srcIeeeAddr; //!< Source IEEE address (0 or 8 Octets)
+    // Multicast Control (1 Octet)
+    MulticastMode m_mcstMode{NONMEMBER}; //!< Multicast mode sub-field (Bits 0-1)
+    uint8_t m_nonMemberRadius;           //!< Non member radius sub-field (Bits 2-4)
+    uint8_t m_maxNonMemberRadius;        //!< Max non member radius sub-field (Bit 5-7)
+
+    // TODO: Add source route subframe
+    // uint8_t m_relayCount; //!< Relay Count Sub-Field
+    // uint8_t m_relayIndex; //!< Relay Index
+    // TODO: Add Relay List when supported
+};
+} // namespace zigbee
+} // namespace ns3
+
+#endif /* ZIGBEE_NWK_HEADER_H */
